'MAKESORT.BAS   Ray Thomas      July 1999

'Program to make the sortation test files

OPTION BASE 1

DIM Count AS LONG               'Loop counter
DIM Counter AS LONG             'Loop counter
DIM Number AS LONG              'General numeric variable
DIM MaxNum AS LONG              'To hold the number of elements created
DIM FilePath AS STRING          'Path to the output files
DIM SwapNum AS LONG             'Number of small / large numbers to swap
DIM NumArray(30000) AS INTEGER  'To test for random numbers

'*** To alter the size of the file produced change the dimension for NumArray ***
'*** Alter FilePath$ below to change the file destinations

'*** Set the program variables ***

FilePath$ = "C:\Ray\"
MaxNum = UBOUND(NumArray)
SwapNum = MaxNum / 5

OPEN FilePath$ + "SORT1.TST" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #1
OPEN FilePath$ + "SORT2.TST" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #2
OPEN FilePath$ + "SORT3.TST" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #3
OPEN FilePath$ + "SORT4.TST" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #4
OPEN FilePath$ + "SORT5.TST" FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #5

'*** Make an array of completely sorted numbers ***

FOR Count = 1 TO MaxNum
        NumArray(Count) = Count
NEXT Count

CLS
RANDOMIZE TIMER
FOR Count = 1 TO MaxNum

        PRINT #5, Count
        LOCATE 2, 2
        PRINT "The loop counter is now"; Count
        PRINT

        Number = (RND * (MaxNum + 1 - Count)) + 1
       
        PRINT #1, NumArray(Number)
        PRINT "The random number generated is"; Number; "               "
        PRINT "from the NumArray this is"; NumArray(Number); "          "
        PRINT
       
        FOR Counter = Number TO MaxNum - Count
                NumArray(Counter) = NumArray(Counter + 1)
        NEXT Counter
   
        Number = MaxNum + 1 - Count          'Completely sorted - but backward
       
        PRINT #2, Number
        PRINT "The backward number is now"; Number
        PRINT

        IF Count < MaxNum - SwapNum THEN           'Nearly sorted - but small numbers at end
                Number = Count + SwapNum + 1
        ELSE Number = MaxNum + 1 - Count
        END IF
        PRINT #3, Number
        PRINT "The nearly sorted, but small numbers at end is now at"; Number; "         "
        PRINT

        IF Count < SwapNum + 1 THEN           'Nearly sorted - but large numbers at start
                Number = Count + MaxNum - SwapNum
        ELSE Number = Count - SwapNum
        END IF
        PRINT #4, Number
        PRINT "The nearly sorted, but large numbers at start is now at"; Number; "        "

NEXT Count
CLOSE
END

