'Midnight        Ray Thomas      May 2000

'A program to investigate what happens to the system clock and
'TIMER functions at midnight

CLS
StartTime$ = TIME$              'Get the time the program was started
StartDate$ = DATE$              'Get the present  system date
TIME$ = "23:59:55"              'Set the system time to just before midnight
ProgStart = TIMER               'Get the number of seconds past midnight
Start = TIMER
ON TIMER(1) GOSUB TimeUp        'Set up the timer interupt
TIMER ON                        'Start the timer interupt
FOR Count = 1 TO 1000000        'A do nothing loop
NEXT Count
TIMER OFF                       'Stop the timer interupt
PRINT "Count ended"; Count
PRINT
PRINT "Press any key to reset the system clock ..."
DO
LOOP UNTIL INKEY$ <> ""
GOSUB ResetTime
END

TimeUp:
'*** Do whatever you want to do after the timer interupts

Finish = TIMER
PRINT
PRINT "The time is now: "; TIME$

'*** Stop the program to read what happens to the counters at midnight

IF TIME$ = "00:00:02" THEN
        TIMER OFF
        PRINT "press any key to continue ..."
        DO
        LOOP UNTIL INKEY$ <> ""
        TIMER ON
END IF

PRINT "The Count is now at:"; Count
PRINT Finish - Start; "seconds elapsed"

'*** This is the part that checks for what happens at midnight
'*** it is here that the start time is greater than the finish time

IF Start > Finish THEN
        PRINT "Amended time elapsed"; 86400 - Start + Finish
        PRINT CINT(86400 - Start + Finish); "rounded amended second(s) elapsed"
ELSE PRINT CINT(Finish - Start); "rounded second(s) elapsed"
END IF
PRINT "The end time is"; Finish
PRINT "The start time is"; Start
Start = TIMER
RETURN

ResetTime:
'*** Work out the total time elapsed
'*** and reset the system date and time

PRINT
PRINT "The date when the program was started was "; StartDate$
PRINT
PRINT "The time when the program was started was "; StartTime$
PRINT
PRINT "The date has changed to "; DATE$
PRINT
PRINT "Resetting the date to "; StartDate$
PRINT
DATE$ = StartDate$
Finish = TIMER
PRINT "The program was running for"; CINT(86400 - ProgStart + Finish); "seconds"
Hours = VAL(LEFT$(StartTime$, 2))
Mins = VAL(MID$(StartTime$, 4, 2))
Secs = VAL(RIGHT$(StartTime$, 2))
Finish = TIMER
Secs = Secs + CINT(86400 - ProgStart + Finish)
IF Secs > 60 THEN
        Mins = Mins + INT(Secs / 60)
        Secs = Secs MOD 60
END IF
IF Mins > 60 THEN
        Hours = Hours + INT(Mins / 60)
        Mins = Mins MOD 60
END IF
NewTime$ = LTRIM$(STR$(Hours)) + ":" + LTRIM$(STR$(Mins)) + ":" + LTRIM$(STR$(Secs))
TIME$ = NewTime$
PRINT
PRINT "The time has been restored to "; TIME$
RETURN

